﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RockPaperScissors
{
    class Program
    {

        // Kő-papír-olló játék.
        // A játékostól bekérünk egy figurát és generálunk egy másik figurát a gépi játékos nevében.
        // A mutatott figurák alapján eldöntjük ki nyert, és kiírjuk az eredményt.
        // Addig indítunk újabb játékot, míg a játékos ki nem lép.
        static void Main(string[] args)
        {
            bool newGame = true;        // Addig iterálunk a lenti ciklusban, míg a játékos ki nem lép (newGame == false lesz). Kezdetben a játékos szeretne játszani (newGame == true)
            Random rnd = new Random();  // Új randomszámgenerátor létrehozása. A Next(...) hívás ad vissza egy következő véletlen számot
            string inputString;         // Ebbe a stringbe fogjuk később beolvasni a játékos által begépelt szöveget

            while (newGame)             // Addig indítunk újabb és újabb játékot, míg a játékos ki nem lép
            {
                Console.Clear();        // Minden játék elején letöröljük a konzol ablakot

                string playerFigureString = "";   // Ebben tároljuk a játékos által mutatott figurát, stringként. Azért így, mert így fogjuk beolvasni
                bool validFigureRead = false;     // A lenti ciklus addig tart, míg ez a változó igaz nem lesz: vagyis amíg a játékos érvényes figurát nem ad meg
                do                                // Addig kérünk be egy stringet a játékostól, míg érvényes figurát nem ad meg
                {
                    Console.WriteLine("Mit mutatsz?");
                    inputString = Console.ReadLine();   // Bekérjük a figurát

                    // Az alábbiakban megnézzük, hogy a begépelt érték megegyezik-e valamelyik érvényes figurával.
                    // Ha igen, a felhasználó által mutatott figurát (playerFigureString) beállítjuk a beolvasott értékre 
                    //    és a kiléphetünk a ciklusból, azaz a ciklusváltozót (validFigureRead) átbillentjük igazra.
                    if (inputString == "ko" || inputString == "papir" || inputString == "ollo")
                    {
                        playerFigureString = inputString;
                        validFigureRead = true;
                    }
                    // Egyébként pedig kiírunk valami hibaüzenetet a játékosnak, hogy legközelebb érvényes figurát írjon be
                    else
                    {
                        Console.WriteLine("Ervenyes megadhato figurak: ko, papir, ollo");
                    }
                } while (!validFigureRead);      // Addig kérünk be egy stringet a játékostól, míg érvényes figurát nem ad meg

                int compFigure = rnd.Next(0, 3);  // Véletlen szám generálása (0: kő, 1: papír, 2: olló). Next(min, max), min és max-1 között ad vissza értékeket, tehát max nincs benne
                // A fentebb generált véletlen figurát (amit a gépi játékos "mutat") számként generáltuk. 
                //  - A játékosnak a szám nem mond semmit, úgyhogy átkonvertáljuk string-be és úgy írjuk ki.
                // Ez sok, átláthatatlan if utasítással bonyolítja a kódot, úgyhogy későbbi változatban kitesszük alprogramba.
                // 
                // Vegyük észre azt is, hogy a számok string megfelelője (ko, papir, ollo) többször is szerepel a kódban (int->string és a győztes meghatározása).
                // Ha később módosítani szeretnénk (pl. angolra), akkor mindenhol át kell írni. 
                // Későbbi változatban beletesszük majd egy tömbbe a neveket, és ezt a tömböt használjuk a int-string konverzióra. Így változtatás esetén egy helyen kell módosítanunk.
                string compFigureString = "";
                if (0 == compFigure)
                {
                    compFigureString = "ko";
                }
                if (1 == compFigure)
                {
                    compFigureString = "papir";
                }
                if (2 == compFigure)
                {
                    compFigureString = "ollo";
                }
                Console.WriteLine("A gep ezt mutatta: " + compFigureString);

                // Megnézzük ki nyert. Ez megint egy jó bonyolult if-sorozat. Az áttekinthetőség kedvéért a későbbi változatban ez is alprogram lesz.
                if ("ko" == compFigureString && "papir" == playerFigureString    // ko + papir
                    ||                                                           // vagy
                    "papir" == compFigureString && "ollo" == playerFigureString  // papir + ollo
                    ||                                                           // vagy
                    "ollo" == compFigureString && "ko" == playerFigureString     // ollo + ko
                ) // if feltételének záró zárójele
                {
                    // a játékos nyert
                    Console.WriteLine("Gratulalunk, nyertel!");
                }
                // Ha a két figura megegyezik, döntetlen
                else if (compFigureString == playerFigureString)
                {
                    Console.WriteLine("Dontetlen!");
                }
                // Ha a fenti két eset egyike sem teljesül, akkor (mivel nincs 4. eset), a gép nyert.
                // Vegyük észre, hogy "if - else if - else" struktúrát használtunk, így vizsgáljuk meg a három egymást kizáró esetet.
                // Ha a 2. if elől elhagyjuk az "else"-t már más a program jelentése!
                else
                {
                    Console.WriteLine("Sajnos a gep nyert :-(");
                }

                // Rákérdezünk a játékostól, hogy szeretne-e új játékot.
                // Addig olvasunk be szöveget, míg az "i" vagy "n" betű valamelyikét be nem gépelte
                Console.WriteLine();
                Console.WriteLine("Uj jatek? (i/n)");
                do
                {
                    inputString = Console.ReadLine();
                } while (!(inputString == "i" || inputString == "n"));  // Csak akkor lépünk tovább, ha "i" vagy "n" betűt ütött be a játékos

                if (inputString == "n")  // ha "n" betűt kaptunk, kiléphetünk a fő (while) ciklusból.
                {
                    newGame = false;
                }
            }
        }
    }

}
